| Version: 3.0.1

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Attributes | List of all members
wxRichTextImageBlock Class Reference
Rich Text

`#include <wx/richtext/richtextbuffer.h>`

Inheritance diagram for wxRichTextImageBlock:
[legend]

## Detailed Description

This class stores information about an image, in binary in-memory form.

##

Library: wxRichText
Category: Rich Text

See Also
  wxRichTextBuffer, wxRichTextCtrl

## Public Member Functions

| wxRichTextImageBlock ()
| Constructor.
| wxRichTextImageBlock (const wxRichTextImageBlock &block)
| Copy constructor.
virtual | ~wxRichTextImageBlock ()
void | Init ()
| Initialises the block.
void | Clear ()
| Clears the block.
virtual bool | MakeImageBlock (const wxString &filename, wxBitmapType imageType, wxImage &image, bool convertToJPEG=true)
| Load the original image into a memory block.
virtual bool | MakeImageBlock (wxImage &image, wxBitmapType imageType, int quality=80)
| Make an image block from the wxImage in the given format.
virtual bool | MakeImageBlockDefaultQuality (const wxImage &image, wxBitmapType imageType)
| Uses a const wxImage for efficiency, but can't set quality (only relevant for JPEG)
virtual bool | DoMakeImageBlock (const wxImage &image, wxBitmapType imageType)
| Makes the image block.
bool | Write (const wxString &filename)
| Writes the block to a file.
bool | WriteHex (wxOutputStream &stream)
| Writes the data in hex to a stream.
bool | ReadHex (wxInputStream &stream, int length, wxBitmapType imageType)
| Reads the data in hex from a stream.
void | Copy (const wxRichTextImageBlock &block)
| Copy from block.
bool | Load (wxImage &image)
void | operator= (const wxRichTextImageBlock &block)
| Assignment operation.
unsigned char * | GetData () const
| Returns the raw data.
size_t | GetDataSize () const
| Returns the data size in bytes.
wxBitmapType | GetImageType () const
| Returns the image type.
void | SetData (unsigned char *image)
void | SetDataSize (size_t size)
| Sets the data size.
void | SetImageType (wxBitmapType imageType)
| Sets the image type.
bool | IsOk () const
| Returns true if the data is non-NULL.
bool | Ok () const
wxString | GetExtension () const
| Gets the extension for the block's type.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Static Public Member Functions

static unsigned char * | ReadBlock (wxInputStream &stream, size_t size)
| Implementation.
static unsigned char * | ReadBlock (const wxString &filename, size_t size)
| Allocates and reads from a file as a block of memory.
static bool | WriteBlock (wxOutputStream &stream, unsigned char *block, size_t size)
| Writes a memory block to stream.
static bool | WriteBlock (const wxString &filename, unsigned char *block, size_t size)
| Writes a memory block to a file.

## Protected Attributes

unsigned char * | m_data
size_t | m_dataSize
wxBitmapType | m_imageType
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Additional Inherited Members

Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.

## Constructor & Destructor Documentation

wxRichTextImageBlock::wxRichTextImageBlock | ( |  | ) |

Constructor.

wxRichTextImageBlock::wxRichTextImageBlock | ( | const wxRichTextImageBlock & | block | ) |

Copy constructor.

virtual wxRichTextImageBlock::~wxRichTextImageBlock | ( |  | ) |

virtual

## Member Function Documentation

void wxRichTextImageBlock::Clear | ( |  | ) |

Clears the block.

void wxRichTextImageBlock::Copy | ( | const wxRichTextImageBlock & | block | ) |

Copy from block.

virtual bool wxRichTextImageBlock::DoMakeImageBlock | ( | const wxImage & | image,
|  | wxBitmapType | imageType
| ) |  |

virtual

Makes the image block.

unsigned char* wxRichTextImageBlock::GetData | ( |  | ) | const

inline

Returns the raw data.

size_t wxRichTextImageBlock::GetDataSize | ( |  | ) | const

inline

Returns the data size in bytes.

wxString wxRichTextImageBlock::GetExtension | ( |  | ) | const

Gets the extension for the block's type.

wxBitmapType wxRichTextImageBlock::GetImageType | ( |  | ) | const

inline

Returns the image type.

void wxRichTextImageBlock::Init | ( |  | ) |

Initialises the block.

bool wxRichTextImageBlock::IsOk | ( |  | ) | const

inline

Returns true if the data is non-NULL.

bool wxRichTextImageBlock::Load | ( | wxImage & | image | ) |

virtual bool wxRichTextImageBlock::MakeImageBlock | ( | const wxString & | filename,
|  | wxBitmapType | imageType,
|  | wxImage & | image,
|  | bool | convertToJPEG = `true`
| ) |  |

virtual

Load the original image into a memory block.

If the image is not a JPEG, we must convert it into a JPEG to conserve space. If it's not a JPEG we can make use of image, already scaled, so we don't have to load the image a second time.

virtual bool wxRichTextImageBlock::MakeImageBlock | ( | wxImage & | image,
|  | wxBitmapType | imageType,
|  | int | quality = `80`
| ) |  |

virtual

Make an image block from the wxImage in the given format.

virtual bool wxRichTextImageBlock::MakeImageBlockDefaultQuality | ( | const wxImage & | image,
|  | wxBitmapType | imageType
| ) |  |

virtual

Uses a const wxImage for efficiency, but can't set quality (only relevant for JPEG)

bool wxRichTextImageBlock::Ok | ( |  | ) | const

inline

void wxRichTextImageBlock::operator= | ( | const wxRichTextImageBlock & | block | ) |

Assignment operation.

static unsigned char* wxRichTextImageBlock::ReadBlock | ( | wxInputStream & | stream,
|  | size_t | size
| ) |  |

static

Implementation.

Allocates and reads from a stream as a block of memory.

static unsigned char* wxRichTextImageBlock::ReadBlock | ( | const wxString & | filename,
|  | size_t | size
| ) |  |

static

Allocates and reads from a file as a block of memory.

bool wxRichTextImageBlock::ReadHex | ( | wxInputStream & | stream,
|  | int | length,
|  | wxBitmapType | imageType
| ) |  |

Reads the data in hex from a stream.

void wxRichTextImageBlock::SetData | ( | unsigned char * | image | ) |

inline

void wxRichTextImageBlock::SetDataSize | ( | size_t | size | ) |

inline

Sets the data size.

void wxRichTextImageBlock::SetImageType | ( | wxBitmapType | imageType | ) |

inline

Sets the image type.

bool wxRichTextImageBlock::Write | ( | const wxString & | filename | ) |

Writes the block to a file.

static bool wxRichTextImageBlock::WriteBlock | ( | wxOutputStream & | stream,
|  | unsigned char * | block,
|  | size_t | size
| ) |  |

static

Writes a memory block to stream.

static bool wxRichTextImageBlock::WriteBlock | ( | const wxString & | filename,
|  | unsigned char * | block,
|  | size_t | size
| ) |  |

static

Writes a memory block to a file.

bool wxRichTextImageBlock::WriteHex | ( | wxOutputStream & | stream | ) |

Writes the data in hex to a stream.

## Member Data Documentation

unsigned char* wxRichTextImageBlock::m_data

protected

size_t wxRichTextImageBlock::m_dataSize

protected

wxBitmapType wxRichTextImageBlock::m_imageType

protected